#include <mpi.h>
#include <stdio.h>
#include <math.h>

main(int argc, char* argv[]) {
  int rank,size;
  MPI_Status status;
  int i;
  double ism[40],sum;
  MPI_Datatype weave_type;
  MPI_Init(&argc,&argv);
  MPI_Comm_rank(MPI_COMM_WORLD,&rank);
  MPI_Comm_size(MPI_COMM_WORLD,&size);
  MPI_Type_vector(20,1,2,MPI_DOUBLE,&weave_type);
  MPI_Type_commit(&weave_type);
  for (i=0;i<40;++i) {
    ism[i]=0.0;
  }
  if (rank==0) {
    for (i=0;i<40;++i) {
       ism[i]=pow(i,2.5);
    }
    MPI_Send(&ism[0],1,weave_type,2,1701,MPI_COMM_WORLD);
    MPI_Send(&ism[1],1,weave_type,1,1701,MPI_COMM_WORLD);
  } else {
    if (rank==1)  
      MPI_Recv(&ism[1],1,weave_type,0,1701,MPI_COMM_WORLD,&status);
    else
      MPI_Recv(&ism[0],1,weave_type,0,1701,MPI_COMM_WORLD,&status);
    sum=0.0;
    for(i=0;i<40;++i) {
      sum += ism[i];
    }
    if (rank==1)
      printf("P:%d average of the odd elements=%f\n",rank,sum/20.0);
    else
      printf("P:%d average of the even elements=%f\n",rank,sum/20.0);
  }
  MPI_Finalize();
}
